#include <iostream>

template<typename T>
class Stapel {
public:
	Stapel();         // Konstruktor
	void push(T &x);  // Element auf den Stapel legen
	void pop();       // oberstes Element entfernen
	T top();          // oberstes Element ansehen
	bool empty();     // Stapel leer?
	bool full();      // Stapel voll?
private:
	static unsigned int const maxSize = 100;
	int sz;           // Stapelzeiger
	T data[maxSize];  // Speichervorat für Nutzdaten
	void error(char const *info); // Fehlermeldung + Abbruch
};

template<typename T>
Stapel<T>::Stapel() {
	sz = -1;
}
template<typename T>
void Stapel<T>::push(T &x) {
	if (full()) error("voll");
	data[++sz] = x;
}
template<typename T>
void Stapel<T>::pop() {
	if (empty()) error("leer");
	sz--;
}
template<typename T>
T Stapel<T>::top() {
	if (empty()) error("leer");
	return data[sz];
}
template<typename T>
bool Stapel<T>::empty() {
	return (sz == -1);
}
template<typename T>
bool Stapel<T>::full() {
	return (sz == maxSize - 1);
}
template<typename T>
void Stapel<T>::error(char const * info) {
	std::cerr << info << std::endl;
	exit(1);
}
