template<typename T>
class Schlange {
public:
	Schlange();           // Konstruktor
	void enq(T &x);       // Element anhängen
	void deq();           // erstes Element entfernen
	T front();            // erstes Element ansehen
	bool empty();         // Schlange leer?
	bool full();          // Schlange voll?
private:
	static unsigned int const maxSize = 100;
	int ez;               // Endezeiger
	T data[maxSize];      // Array für Nutzdaten
	void error(char const *info);  // Fehlermeldung
};

template<typename T>
Schlange<T>::Schlange() : ez(-1) {
}
template<typename T>
void Schlange<T>::enq(T &x) {
	if (full()) error("voll");
	data[++ez] = x;
}
template<typename T>
void Schlange<T>::deq() {
	if (empty()) error("leer");
	for (int i = 0; i < ez; i++)
		data[i] = data[i+1];
	ez--;
}
template<typename T>
T Schlange<T>::front() {
	if (empty()) error("leer");
	return data[0];
}
template<typename T>
bool Schlange<T>::empty() {
	return (ez == -1);
}
template<typename T>
bool Schlange<T>::full() {
	return (ez == maxSize - 1);
}
template<typename T>
void Schlange<T>::error(char const *info) {
	std::cerr << info << std::endl;
	exit(1);
}
