#include <iostream>

using namespace std;

template<typename T>
class Schlange {
public:
	Schlange();			// Konstruktor
	void enq(T &x);       
	void deq();
	T front();
	bool empty();
	void clear();		// löscht alle Einträge
	~Schlange();		// Destruktor
private:
	struct Objekt {		// interner Datentyp
		Objekt *tail;	// Zeiger auf Schlangenschwanz 
		T       data;	// Datenfeld
	} *sz, *ez;			// Zeiger auf Start + Ende
	void error(char const *info); // für Fehlermeldungen
};

template<typename T>
Schlange<T>::Schlange() {
	ez = sz = nullptr;
}
template<typename T>
T Schlange<T>::front() {
	if (empty()) error("leer");
	return sz->data;
}
template<typename T>
bool Schlange<T>::empty() {
	return (ez == nullptr);
}
template<typename T>
void Schlange<T>::clear() {
	while (!empty()) deq();
}
template<typename T>
Schlange<T>::~Schlange() {
	clear();
}
template<typename T>
void Schlange<T>::error(char const *info){
	cerr << info << endl;
	exit(1);
}
template<typename T>
void Schlange<T>::enq(T &x) {
	Objekt *obj = new Objekt; // neues Objekt anlegen
	obj->data = x;            // Nutzdaten speichern
	obj->tail = nullptr;
	if (empty()) sz = obj;    // falls leer nach vorne,
	else ez->tail = obj;      // sonst hinten anhängen
	ez = obj;                 // Endezeiger aktualisieren
}
template<typename T>
void Schlange<T>::deq() {
	if (empty()) error("leer");
	Objekt *obj = sz;         // Zeiger auf Kopf retten
	sz = sz->tail;            // Start auf 2. Element
	if (sz == nullptr) ez = nullptr;  // Schlange leer!
	delete obj;               // ehemaliges 1. Element
}                             //               löschen
