#include <iostream>
#include "Graph.h"
using namespace std;

Graph::Graph(uint NoOfNodes) {
	mNoOfNodes = NoOfNodes;
	if (mNoOfNodes > 0) 
		mAdjList = new Liste<uint>[mNoOfNodes];
}
Graph::~Graph() {
	if (mNoOfNodes > 0) delete[] mAdjList;
}
void Graph::printGraph() {
	for (uint i = 0; i < mNoOfNodes; i++) {
		cout << i << " : ";
		mAdjList[i].print();
	}
}
void Graph::addEdge(uint Node1, uint Node2) {
	if (!hasEdge(Node1, Node2)) {
		mAdjList[Node1].append(Node2);
		mAdjList[Node2].append(Node1);
	}
}
bool Graph::hasEdge(uint Node1, uint Node2) {
	if (mNoOfNodes < 1) return false;
	return mAdjList[Node1].is_elem(Node2);
}
uint Graph::noOfEdges() {
	uint cnt = 0;
	for (uint i = 0; i < mNoOfNodes; i++)
		cnt += mAdjList[i].size();
	return cnt / 2;
}
uint Graph::noOfNodes() {
	return mNoOfNodes;
}
