#include <iostream>

template<typename T>
class Liste {
public:
	Liste();                  // Konstruktor
	Liste(const Liste<T>& liste);// Kopierkonstruktor
	void append(const T& x);  // hängt hinten an
	void prepend(const T& x); // fügt vorne ein
	bool empty();             // Liste leer?
	bool is_elem(const T& x); // ist Element x in Liste?
	void clear();             // Liste leeren
	void print();             // Liste ausgeben
	unsigned int size();      // Elemente zählen
	~Liste();                 // Destruktor
private:
	struct Objekt {           // privater Datentyp
		T       data;         // Nutzdaten
		Objekt *next;         // Zeiger auf nächstes Objekt
	} *sz, *ez;               // Startzeiger auf Listenkopf
	void clear(Objekt *obj);  // Hilfsmethode zum Leeren
};

template<typename T>
Liste<T>::Liste() {
	ez = sz = nullptr;
}
template<typename T>
bool Liste<T>::empty() {
	return (ez == nullptr);
}
template<typename T>
Liste<T>::~Liste() {
	clear();
}
template<typename T>
void Liste<T>::clear(Objekt *obj) {
	if (obj == nullptr) return;
	clear(obj->next);
	delete obj;
}
template<typename T>
void Liste<T>::clear() {
	clear(sz);
	ez = sz = nullptr;
}
template<typename T>
void Liste<T>::print() {
	for (Objekt *ptr = sz; ptr != nullptr; ptr = ptr->next) {
		std::cout << ptr->data << " ";
	}
	std::cout << std::endl;
}
template<typename T>
unsigned int Liste<T>::size() {
	unsigned int count = 0;
	for (Objekt *ptr = sz; ptr != nullptr; ptr = ptr->next) {
		count++;
	}
	return count;
}
template<typename T>
bool Liste<T>::is_elem(const T& x) {
	Objekt *ptr = sz;
	while (ptr != nullptr) {
		if (ptr->data == x) return true;
		ptr = ptr->next;
	}
	return false;
}
template<typename T>
void Liste<T>::prepend(const T& x){
	Objekt *obj = new Objekt;
	obj->data = x;
	obj->next = sz;
	sz = obj;
	if (empty()) ez = obj;
}
template<typename T>
void Liste<T>::append(const T& x) {
	Objekt *obj = new Objekt;
	obj->data = x;
	obj->next = nullptr;
	if (empty()) sz = obj;
	else ez->next = obj;
	ez = obj;
}
template<typename T>
Liste<T>::Liste(const Liste<T>& liste) {
	ez = nullptr;
	for (Objekt *ptr = liste.sz; ptr != nullptr; ptr = ptr->next)
		append(ptr->data);
}
